import requests
from bs4 import BeautifulSoup
from bs4.element import NavigableString
import openpyxl


device_id = ''


class Pledges:
    def __init__(self, name, last_modified, contained, pledge_id):
        self.name = name
        self.last_modified = last_modified
        self.contained = contained
        self.pledge_id = pledge_id


class AccountPledges(Pledges):
    def __init__(self, name, last_modified, contained, pledge_id, image, value, status):
        super().__init__(name, last_modified, contained, pledge_id)
        self.image = image
        self.value = value
        self.status = status


class BuyBackPledges:
    def __init__(self, rsi_token, rsi_xsrf):
        self.current_page = 1
        self.pledges = []
        self.device = device_id
        self.rsi_token = rsi_token
        self.rsi_xsrf = rsi_xsrf
        self.is_end = False
        self.max_page = 0
        self.site_url = 'https://robertsspaceindustries.com/account/buy-back-pledges'
        self.my_headers = {
            'accept': 'text/html,application/xhtml+xml,application/xml;q=0.9,'
                      'image/avif,image/webp,image/apng,*/*;q=0.8,application/signed-exchange;v=b3;q=0.9',
            'accept-language': 'zh-CN,zh;q=0.9,en;q=0.8',
            'cookie': '_ga=GA1.2.1818646452.1606812201; wsc_view_count=1; wsc_hide=true; __stripe_mid=8275bb1f-755b-400d-bb5d-148b6e027c0b1a9332; notification__privacy__xalvbabalttku=1; notification__privacy__w29v6zurhelps=1; _rsi_device=5ix6ixyyeth82ak4ta4n2ow0zz; _gaexp=GAX1.2.3xtz0OALSaqezAZeQN7AeA.18833.0; CookieConsent={stamp:%27-1%27%2Cnecessary:true%2Cpreferences:true%2Cstatistics:true%2Cmarketing:true%2Cver:1%2Cutc:1620999446249%2Cregion:%27CN%27}; _gcl_au=1.1.1279106605.1620999449; ' + 'Rsi-Token={}; Rsi-XSRF={}; _gid=GA1.2.1056420711.1623184338'.format(rsi_token, rsi_xsrf),
            'user-agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/90.0.4430.212 Safari/537.36',
            'referer': self.site_url
        }
        self.lib = {}
        self.get_pledges()

    def get_html_content(self):
        return requests.get(self.site_url + '?page={}&pagesize=100'.format(self.current_page), headers=self.my_headers)

    def create_lib(self):
        for pledge in self.pledges:
            if pledge.name not in self.lib:
                self.lib[pledge.name] = {
                    'num': 1,
                    'pledge_id': pledge.pledge_id,
                    'contained': pledge.contained,
                    'last_modified': [pledge.last_modified]
                }
            else:
                self.lib[pledge.name]['last_modified'].append(pledge.last_modified)
                self.lib[pledge.name]['num'] += 1

    def get_pledges(self):
        response = self.get_html_content()
        soup = BeautifulSoup(response.text, "html.parser")
        pledges = soup.find_all("ul", class_="pledges")
        try:
            max_page_url = soup.find_all('a', class_='raquo btn')[0].get('href')
            max_page_url = max_page_url.replace('/account/buy-back-pledges?page=', '')
            max_page_url = max_page_url.replace('&pagesize=100', '')
            self.max_page = int(max_page_url)
        except:
            pass
        if '/account/buy-back-pledges?page={}&pagesize=100'.format(self.current_page+1) not in response.text:
            self.is_end = True
        my_pledges = []
        for li in pledges[0]:
            if not isinstance(li, NavigableString):
                pledge_name = li.select('h1')[0].string
                pledge_id = li.select('a')[0].get('data-pledgeid')
                last_modified = li.select('dl')[0].dd.contents[0]
                contained = li.select('dl')[0]
                contained = contained.contents[3]
                contained = contained.contents[1]
                contained = contained.contents[3]
                contained = contained.contents[0]
                if not pledge_id:
                    pledge_id = li.select('a')[0].get('href').split('/')[-1]
                pledge = Pledges(name=pledge_name, last_modified=last_modified, contained=contained, pledge_id=pledge_id)
                my_pledges.append(pledge)
        self.pledges += my_pledges
        return my_pledges

    def get_next(self):
        if not self.is_end:
            self.current_page += 1
            return self.get_pledges()
        else:
            return None

    def get_all(self):
        self.get_pledges()
        while not self.is_end:
            self.get_next()
        return self.pledges

    def save_to_excel(self, savepath):
        self.create_lib()
        wb = openpyxl.Workbook()
        wb.create_sheet('buy_back_pledges')
        sh = wb['buy_back_pledges']
        labels = ['NAME', 'SUM', 'CONTAINED', 'PLEDGE ID', 'LAST MODIFIED']
        for i in range(0, len(labels)):
            sh.cell(row=1, column=i + 1, value=labels[i])
        data_labels = ['num', 'contained', 'pledge_id', 'last_modified']
        i = 2
        for name in self.lib:
            sh.cell(row=i, column=1, value=name)
            for j in range(0, len(data_labels)):
                # if type(self.lib[name][data_labels[j]]) == str:
                try:
                    sh.cell(row=i, column=j + 2, value=self.lib[name][data_labels[j]])
                except ValueError:
                    sh.cell(row=i, column=j + 2, value=','.join(self.lib[name][data_labels[j]]))
                # else:
                #     sh.cell(row=i, column=j+2, value=','.join(self.lib[name][data_labels[j]]))
            i += 1
        wb.save(savepath)


class AccountPledge(BuyBackPledges):
    def __init__(self, rsi_token, rsi_xsrf):
        super().__init__(rsi_token, rsi_xsrf)
        self.total_value = 0

    def get_html_content(self):
        self.site_url = ''
        return requests.get('https://robertsspaceindustries.com/account/pledges' + '?page={}&pagesize=10'.
                            format(self.current_page), headers=self.my_headers)

    def get_pledges(self):
        response = self.get_html_content()
        soup = BeautifulSoup(response.text, "html.parser")
        pledges = soup.find_all("ul", class_="list-items")
        try:
            max_page_url = soup.find_all('a', class_='raquo btn')[0].get('href')
            max_page_url = max_page_url.replace('/account/pledges?page=', '')
            max_page_url = max_page_url.replace('&pagesize=10', '')
            self.max_page = int(max_page_url)
        except:
            pass
        if self.current_page >= self.max_page:
            self.is_end = True
        my_pledges = []
        for li in pledges[0]:
            if not isinstance(li, NavigableString):
                pledge_name = li.select('input[class="js-pledge-name"]')[0].get('value')
                value = li.select('input[class="js-pledge-value"]')[0].get('value')
                pledge_id = li.select('input[class="js-pledge-id"]')[0].get('value')
                status = li.select('span[class="availability"]')[0].string
                image = li.select('div[class="image"]')[0].get('style')
                last_modified = li.select('div[class="date-col"]')[0].contents[2].replace(' ', '').replace('\n', '')
                contained = li.select('div[class="items-col"]')[0].contents[2].replace('\n', '').replace('                ', '')
                pledge = AccountPledges(name=pledge_name, last_modified=last_modified, contained=contained,
                                 pledge_id=pledge_id, image=image, value=value, status=status)
                my_pledges.append(pledge)
        self.pledges += my_pledges
        return my_pledges

    def create_lib(self):
        self.total_value = 0
        for pledge in self.pledges:
            self.total_value += float(pledge.value.replace(' USD', '').replace('$', ''))
            if pledge.name not in self.lib:
                self.lib[pledge.name] = {
                    'num': 1,
                    'pledge_id': pledge.pledge_id,
                    'contained': pledge.contained,
                    'last_modified': [pledge.last_modified],
                    'value': pledge.value,
                    'status': pledge.status
                }
            else:
                self.lib[pledge.name]['last_modified'].append(pledge.last_modified)
                self.lib[pledge.name]['num'] += 1

    def save_to_excel(self, savepath):
        self.create_lib()
        wb = openpyxl.Workbook()
        wb.create_sheet('pledges')
        sh = wb['pledges']
        labels = ['NAME', 'SUM', 'CONTAINED', 'PLEDGE ID', 'VALUE', 'STATUS', 'LAST MODIFIED']
        for i in range(0, len(labels)):
            sh.cell(row=1, column=i + 1, value=labels[i])
        data_labels = ['num', 'contained', 'pledge_id', 'value', 'status', 'last_modified']
        i = 2
        for name in self.lib:
            sh.cell(row=i, column=1, value=name)
            for j in range(0, len(data_labels)):
                # if type(self.lib[name][data_labels[j]]) == str:
                try:
                    sh.cell(row=i, column=j + 2, value=self.lib[name][data_labels[j]])
                except ValueError:
                    sh.cell(row=i, column=j + 2, value=','.join(self.lib[name][data_labels[j]]))
                # else:
                #     sh.cell(row=i, column=j+2, value=','.join(self.lib[name][data_labels[j]]))
            i += 1
        sh.cell(row=i, column=5, value='${} USD'.format(round(self.total_value, 2)))
        wb.save(savepath)

#
# def create_work_book(count_library, savepath):
#     wb = openpyxl.Workbook()
#     wb.create_sheet('buy_back_pledges')
#     sh = wb['buy_back_pledges']
#     labels = ['NAME', 'SUM', 'CONTAINED', 'PLEDGE ID', 'LAST MODIFIED']
#     for i in range(0, len(labels)):
#         sh.cell(row=1, column=i+1, value=labels[i])
#     data_labels = ['num', 'contained', 'pledge_id', 'last_modified']
#     i = 2
#     for name in count_library:
#         sh.cell(row=i, column=1, value=name)
#         for j in range(0, len(data_labels)):
#             # if type(count_library[name][data_labels[j]]) == str:
#             try:
#                 sh.cell(row=i, column=j+2, value=count_library[name][data_labels[j]])
#             except ValueError:
#                 sh.cell(row=i, column=j + 2, value=','.join(count_library[name][data_labels[j]]))
#             # else:
#             #     sh.cell(row=i, column=j+2, value=','.join(count_library[name][data_labels[j]]))
#         i += 1
#     wb.save(savepath)


# def get_buyback_pledges(rsi_token, rsi_xsrf):
#     buy_back_pledges = BuyBackPledges(rsi_token=rsi_token,
#                                       rsi_xsrf=rsi_xsrf)
#     buy_back_pledges.get_all()
#     count_library = {}
#     for pledge in buy_back_pledges.pledges:
#         if pledge.name not in count_library:
#             count_library[pledge.name] = {
#                 'num': 1,
#                 'pledge_id': pledge.pledge_id,
#                 'contained': pledge.contained,
#                 'last_modified': [pledge.last_modified]
#             }
#         else:
#             count_library[pledge.name]['last_modified'].append(pledge.last_modified)
#             count_library[pledge.name]['num'] += 1
#     create_work_book(count_library, 'buy_back_pledges_list.xlsx')


if __name__ == "__main__":
    rsi_token = input('请输入你的Rsi_Token:')
    rsi_xsrf = input('请输入你的Rsi_XSRF:')
    device_id = input('请输入你的Rsi_device:')
    account_pledges = AccountPledge(rsi_token=rsi_token,
                                    rsi_xsrf=rsi_xsrf)
    account_pledges.get_all()
    account_pledges.save_to_excel('pledges.xlsx')

    buyback_pledges = BuyBackPledges(rsi_token=rsi_token,
                                     rsi_xsrf=rsi_xsrf)
    buyback_pledges.get_all()
    buyback_pledges.save_to_excel('buy_back_pledges.xlsx')

    pass

